scala.tools.nsc.transform.LazyVals

# LazyValues

#### class LazyValues extends TypingTransformer

Transform local lazy accessors to check for the initialized bit.

Source
  LazyVals.scala

Linear Supertypes
LazyVals.TypingTransformer, Global.Transformer, Global.Transformer, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. LazyValues
2. TypingTransformer
3. Transformer
4. Transformer
5. AnyRef
6. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new LazyValues(unit: Global.CompilationUnit)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from LazyValues to any2stringadd[LazyValues] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (LazyValues, B)

   Implicit information
     This member is added by an implicit conversion from LazyValues to ArrowAssoc[LazyValues] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### def atOwner[A](tree: Global.Tree, owner: Global.Symbol)(trans: ⇒ A): A

   Definition Classes
     TypingTransformer

8. #### final def atOwner[A](owner: Global.Symbol)(trans: ⇒ A): A

   Definition Classes
     TypingTransformer → Transformer

9. #### val bitmaps: Map[Global.Symbol, collection.immutable.List[Global.Symbol]]

10. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

11. #### var curTree: Global.Tree

    Attributes
      protected
    Definition Classes
      TypingTransformer

12. #### def currentClass: Global.Symbol

    Attributes
      protected
    Definition Classes
      Transformer

13. #### def currentMethod: Global.Symbol

    Attributes
      protected
    Definition Classes
      Transformer

14. #### var currentOwner: Global.Symbol

    Attributes
      protected[scala]
    Definition Classes
      Transformer

15. #### def ensuring(cond: (LazyValues) ⇒ Boolean, msg: ⇒ Any): LazyValues

    Implicit information
      This member is added by an implicit conversion from LazyValues to Ensuring[LazyValues] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: (LazyValues) ⇒ Boolean): LazyValues

    Implicit information
      This member is added by an implicit conversion from LazyValues to Ensuring[LazyValues] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean, msg: ⇒ Any): LazyValues

    Implicit information
      This member is added by an implicit conversion from LazyValues to Ensuring[LazyValues] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: Boolean): LazyValues

    Implicit information
      This member is added by an implicit conversion from LazyValues to Ensuring[LazyValues] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

20. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

21. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

22. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from LazyValues to StringFormat[LazyValues] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

23. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

24. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

25. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

26. #### var localTyper: (analyzer)#Typer

    Definition Classes
      TypingTransformer

27. #### def mkFastPathBody(clazz: Global.Symbol, lzyVal: Global.Symbol, cond: Global.Tree, syncBody: List[Global.Tree], stats: List[Global.Tree], retVal: Global.Tree): (Global.Tree, Global.Tree)

28. #### def mkSlowPathDef(clazz: Global.Symbol, lzyVal: Global.Symbol, cond: Global.Tree, syncBody: List[Global.Tree], stats: List[Global.Tree], retVal: Global.Tree): Global.Tree

29. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

30. #### final def notify(): Unit

    Definition Classes
      AnyRef

31. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

32. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

33. #### def toString(): String

    Definition Classes
      AnyRef → Any

34. #### def transform(tree: Global.Tree): Global.Tree

    Perform the following transformations:

    Perform the following transformations:

    - for a lazy accessor inside a method, make it check the initialization bitmap
    - for all methods, add enough int vars to allow one flag per lazy local value
    - blocks in template bodies behave almost like methods. A single bitmaps section is added in the first block, for all lazy values defined in such blocks.
    - remove ACCESSOR flags: accessors in traits are not statically implemented, but moved to the host class. local lazy values should be statically implemented.
    Definition Classes
      LazyValues → TypingTransformer → Transformer

35. #### def transformCaseDefs(trees: List[Global.CaseDef]): List[Global.CaseDef]

    Definition Classes
      Transformer

36. #### def transformIdents(trees: List[Global.Ident]): List[Global.Ident]

    Definition Classes
      Transformer

37. #### def transformMemberDefs(trees: List[Global.MemberDef]): List[Global.MemberDef]

    Definition Classes
      Transformer

38. #### def transformModifiers(mods: Global.Modifiers): Global.Modifiers

    Definition Classes
      Transformer

39. #### def transformStats(stats: List[Global.Tree], exprOwner: Global.Symbol): List[Global.Tree]

    Definition Classes
      Transformer

40. #### def transformTemplate(tree: Global.Template): Global.Template

    Definition Classes
      Transformer

41. #### def transformTrees(trees: List[Global.Tree]): List[Global.Tree]

    Definition Classes
      Transformer

42. #### def transformTypeDefs(trees: List[Global.TypeDef]): List[Global.TypeDef]

    Definition Classes
      Transformer

43. #### def transformUnit(unit: Global.CompilationUnit): Unit

    Definition Classes
      Transformer

44. #### def transformValDef(tree: Global.ValDef): Global.ValDef

    Definition Classes
      Transformer

45. #### def transformValDefs(trees: List[Global.ValDef]): List[Global.ValDef]

    Definition Classes
      Transformer

46. #### def transformValDefss(treess: List[List[Global.ValDef]]): List[List[Global.ValDef]]

    Definition Classes
      Transformer

47. #### val treeCopy: Global.TreeCopier

    Definition Classes
      Transformer

48. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

49. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

50. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

51. #### def →[B](y: B): (LazyValues, B)

    Implicit information
      This member is added by an implicit conversion from LazyValues to ArrowAssoc[LazyValues] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from LazyVals.TypingTransformer

### Inherited from Global.Transformer

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from LazyValues to any2stringadd[LazyValues]

### Inherited by implicit conversion StringFormat from LazyValues to StringFormat[LazyValues]

### Inherited by implicit conversion Ensuring from LazyValues to Ensuring[LazyValues]

### Inherited by implicit conversion ArrowAssoc from LazyValues to ArrowAssoc[LazyValues]

### Ungrouped